package nl.amis.view;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCIteratorBinding;
import oracle.adf.model.servlet.HttpBindingContext;
import oracle.adf.share.ADFContext;
import oracle.adf.share.el.OracleExpressionEvaluatorImpl;
import oracle.adf.view.faces.bi.component.pivotTable.DataCellRange;
import oracle.adf.view.faces.bi.component.pivotTable.DataCellSelectionSet;
import oracle.adf.view.faces.bi.component.pivotTable.Selection;
import oracle.adf.view.faces.bi.component.pivotTable.UIPivotTable;
import oracle.adf.view.faces.bi.model.DataCellIndex;
import oracle.adf.view.faces.bi.model.DataCellKey;

import oracle.adfinternal.view.faces.model.FacesExpressionEvaluator;

import oracle.dss.util.ColumnOutOfRangeException;
import oracle.dss.util.DataAccess;

import oracle.dss.util.DataDirector;
import oracle.dss.util.DataException;
import oracle.dss.util.DataMap;
import oracle.dss.util.MetadataMap;

import oracle.dss.util.QDR;

import oracle.dss.util.RowOutOfRangeException;

import oracle.jbo.Row;
import oracle.jbo.RowSetIterator;
import oracle.jbo.uicli.binding.JUCtrlRangeBinding;

import org.apache.commons.el.ExpressionEvaluatorImpl;

public class TimesheetPivotTableManager {
    private UIPivotTable timesheetPivotTable;

    public TimesheetPivotTableManager() {
    }

    public void setTimesheetPivotTable(UIPivotTable timesheetPivotTable) {
        this.timesheetPivotTable = timesheetPivotTable;
    }

    public UIPivotTable getTimesheetPivotTable() {
        return timesheetPivotTable;
    }

    public String getDescription() {
        Selection sel = timesheetPivotTable.getSelection();
        DataCellSelectionSet cellSet = sel.getDataCells();

        DataAccess da = timesheetPivotTable.getDataModel().getDataAccess();
       // assuming that a single cell is selected!
        DataCellRange cell = cellSet.iterator().next();
        DataCellIndex start =
            cell.getStartIndex(timesheetPivotTable.getDataModel());
        int startRow = start.getRow();
        int startCol = start.getColumn();
        QDR qdr;
        try {
            qdr = da.getValueQDR(startRow, startCol, da.QDR_WITHOUT_PAGE);
            String weekNo = (String)qdr.getDimMember("WeekNo").getData();
            String project = (String)qdr.getDimMember("Project").getData();
            String activity = (String)qdr.getDimMember("Activity").getData();
            String dayOfWeek = (String)qdr.getDimMember("DayOfWeek").getData();


            // now we go to the iterator and find the row with this combination of key values
            // from that row we want to know the Description
            DCIteratorBinding iter = getDataIterator();
            RowSetIterator rsi = iter.getRowSetIterator();
            rsi.reset();
            Row row;
            while (rsi.hasNext()) {

                row = rsi.next();
                oracle.jbo.domain.Number rowWeekno =
                    (oracle.jbo.domain.Number)row.getAttribute("WeekNo");
                String rowDayOfWeek = (String)row.getAttribute("DayOfWeek");
                String rowActivity = (String)row.getAttribute("Activity");
                String rowProject = (String)row.getAttribute("Project");
                // assuming that none of these values can be empty/null
                if (rowWeekno.compareTo(Integer.parseInt(weekNo)) == 0 &&
                    rowDayOfWeek.equalsIgnoreCase(dayOfWeek) &&
                    rowActivity.equalsIgnoreCase(activity) &&
                    rowProject.equalsIgnoreCase(project)) {
                    return (String)row.getAttribute("Description");
                }
            }

        } catch (RowOutOfRangeException e) {
        } catch (ColumnOutOfRangeException e) {
        }


        return "";
    }

    public DCIteratorBinding getDataIterator() {
        ADFContext ctx = ADFContext.getCurrent();
        FacesExpressionEvaluator elev =
            (FacesExpressionEvaluator)ctx.getExpressionEvaluator();
        Object iterator =
            elev.evaluate("#{bindings.TimesheetEntriesIterator}");
        return (DCIteratorBinding)iterator;
    }
}
